Attribute VB_Name = "modRegistry"
Public Enum REG_TOPLEVEL_KEYS
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
End Enum

Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal HKEY As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal HKEY As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal HKEY As Long) As Long
Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal HKEY As Long, ByVal lpValueName As String) As Long

Public Const ERROR_SUCCESS = 0&
Public Const REG_SZ = 1

Public Function GetStringValue(HKEY As REG_TOPLEVEL_KEYS, strPath As String, strValueName As String) As String
    Dim rtn As Long
    Dim keyhandle As Long
    Dim lResult As Long
    Dim strBuf As String * 255
    Dim lngBufSize As Long
    Dim intZeroPos As Integer
    
    rtn = RegOpenKey(HKEY, strPath, keyhandle)
    If rtn <> ERROR_SUCCESS Then Exit Function
    lResult = RegQueryValueEx(keyhandle, strValueName, 0, lValueType, ByVal 0&, lngBufSize)

    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_SZ Then
        lResult = RegQueryValueEx(keyhandle, strValueName, 0&, lValueType, ByVal strBuf, lngBufSize)
        intZeroPos = InStr(strBuf, Chr(0))
            If intZeroPos > 0 Then
            GetStringValue = Left(strBuf, intZeroPos - 1)
            Else
            GetStringValue = strBuf
            End If
        End If
    Else
    GetStringValue = "False"
    End If
rtn = RegCloseKey(keyhandle)
End Function

Public Function SetStringValue(HKEY As REG_TOPLEVEL_KEYS, strPath As String, strValueName As String, strValueData As String) As Boolean
    Dim keyhandle As Long
    Dim rtn As Long
    rtn = RegCreateKey(HKEY, strPath, keyhandle)
        If rtn = ERROR_SUCCESS Then
            rtn = RegSetValueEx(keyhandle, strValueName, 0&, REG_SZ, ByVal strValueData, Len(strValueData))
            SetStringValue = True
        Else
            SetStringValue = False
        End If
        
rtn = RegCloseKey(keyhandle)
End Function

Public Function DeleteValueName(ByVal HKEY As REG_TOPLEVEL_KEYS, ByVal strPath As String, ByVal strValueName As String) As Boolean
    Dim keyhandle As Long
    Dim rtn As Long
    
    rtn = RegOpenKey(HKEY, strPath, keyhandle)
    If rtn <> ERROR_SUCCESS Then Exit Function
    
    rtn = RegDeleteValue(keyhandle, strValueName)
        If rtn = ERROR_SUCCESS Then
        DeleteValueName = True
        Else
        DeleteValueName = False
        End If
rtn = RegCloseKey(keyhandle)
End Function

